/*************************************************************************************
* ShatterFuzz.c
*
* Basic message fuzzing tool
*
* Set hWnd to the target windo
*
* Brett Moore [ brett.moore@security-assessment.com ]
* www.security-assessment.com
*
* Blackhat USA 2004 package
*
*************************************************************************************/
#include <windows.h> 

void check_Window(long hWnd)
{
	// check to see what happened
	if (!IsWindow(hWnd))
	{
		printf("+ Window closed...\n");
		exit(0);
	}
}
int main(int argc, char *argv[]) 
{ 
	long lResult,hWnd;
	long messagecount,messageStart,messageMax;
	char buffertosend[5000];
		
	printf("%% ShatterFuzz - Basic Message Fuzzer\n");
	printf("%% brett.moore@security-assessment.com\n\n");
	
	// Set the message handle here
	hWnd = 0x001C032E;


	// Fill the buffer
	memset(buffertosend,0x0,sizeof(buffertosend));
	memset(buffertosend,0x58,sizeof(buffertosend)-1);	

	// Can set start and max if required
	messageStart = 0;
	messageMax = 65535;

	for (messagecount=messageStart;messagecount<=messageMax;messagecount++)
	{
		if ((messagecount != WM_DESTROY) & (messagecount!=WM_CLOSE) & (messagecount != WM_QUIT) & (messagecount != WM_ENDSESSION))
		{
		
			__try{
			
			printf("+ Sending message %x to child window..0x%xh [ block 1 ]\n",messagecount,hWnd);
			lResult = SendMessage((HWND) hWnd,(UINT) messagecount,0,0);
			check_Window(hWnd);
			
			printf("+ Sending message %x to child window..0x%xh [ block 2 ]\n",messagecount,hWnd);
			lResult = SendMessage((HWND) hWnd,(UINT) messagecount,1,0);
			check_Window(hWnd);
			
			printf("+ Sending message %x to child window..0x%xh [ block 3 ]\n",messagecount,hWnd);
			lResult = SendMessage((HWND) hWnd,(UINT) messagecount,0,1);
			check_Window(hWnd);
			
			printf("+ Sending message %x to child window..0x%xh [ block 4 ]\n",messagecount,hWnd);
			lResult = SendMessage((HWND) hWnd,(UINT) messagecount,1,1);
			check_Window(hWnd);
			
			printf("+ Sending message %x to child window..0x%xh [ block 5 ]\n",messagecount,hWnd);
			lResult = SendMessage((HWND) hWnd,(UINT) messagecount,1,&buffertosend);
			check_Window(hWnd);
			
			printf("+ Sending message %x to child window..0x%xh [ block 6 ]\n",messagecount,hWnd);
			lResult = SendMessage((HWND) hWnd,(UINT) messagecount,0,&buffertosend);
			check_Window(hWnd);
			
			printf("+ Sending message %x to child window..0x%xh [ block 7 ]\n",messagecount,hWnd);
			lResult = SendMessage((HWND) hWnd,(UINT) messagecount,&buffertosend,0);
			check_Window(hWnd);
			
			printf("+ Sending message %x to child window..0x%xh [ block 8 ]\n",messagecount,hWnd);
			lResult = SendMessage((HWND) hWnd,(UINT) messagecount,&buffertosend,1);
			check_Window(hWnd);
			}

			__except(GetExceptionCode() !=0 )
			{
				printf("+ Message %x to child window..0x%xh caused local exception\n",messagecount,hWnd);
			}

		}
	}
	
	printf("+ Done...\n");
	return 0;
}
